<?php

/*
||==========================================================
||		Fusion News 3.x
||----------------------------------------------------------
|| File Version	: $Id: headlines.php 234 2008-07-13 14:44:14Z xycaleth $
|| Contact	: xycaleth@gmail.com
|| Copyright:	: (c) 2006 - 2008, FusionNews.net
|| License Info	: http://www.gnu.org/copyleft/gpl.html
||==========================================================
*/

if ( !defined ('FNEWS_ROOT_PATH') )
{
	define ('FNEWS_ROOT_PATH', str_replace ('\\', '/', dirname (__FILE__)) . '/');
	include_once FNEWS_ROOT_PATH . 'common.php';
}

if ( !isset ($fn_news_url) )
{
	echo 'Please set the URL of your news page (using $fn_news_url).';
	return;
}

$fn_category = ( isset ($fn_category) ) ? intval ($fn_category) : 0;

$file = arrange_by_date();
$total_posts = sizeof ($file);
if ( $total_posts <= 0 )
{
	unset ($fn_news_url);
	return;
}

if ( $flip_news )
{
	$file = array_reverse ($file);
}

$valid_posts = array();
$max_headlines = $total_posts < $numofh ? $total_posts : $numofh;

$other_qs = clean_query_string();

$mark = ( strpos ($fn_news_url, '?') === false ) ? '?' : '&amp;';
for ( $i = 0; $i < $max_headlines; $i++ )
{
	$toc = get_line_data ('news_toc', $file[$i]);
	
	$categories = explode (',', $toc['categories']);
	if ( $fn_category !== 0 && !in_array ($fn_category, $categories) )
	{
		continue;
	}
	
	if ( !file_exists (FNEWS_ROOT_PATH . 'news/news.' . $toc['news_id'] . '.php') )
	{
		continue;
	}
	
	$news_file = file (FNEWS_ROOT_PATH . 'news/news.' . $toc['news_id'] . '.php');
	
	$news_info = parse_news_to_view ($news_file[1], $fn_category);
	
	$temp_head = get_template ('headline_temp.php', false);
	$temp_head = replace_masks ($temp_head, array (
		'post_id'		=> $news_info['post_id'],
		'subject'		=> $news_info['subject'],
		'description'	=> $news_info['description'],
		'user'		=> $news_info['writer'],
		'icon'		=> $news_info['icon'],
		'date'		=> $news_info['date'],
		'cat_icon'		=> $news_info['cat_icon'],
		'cat_name'		=> $news_info['cat_name'],
		'cat_id'		=> $news_info['cat_id'],
		'linkend'		=> '</a>'
	));
	
	if ( ($i > $numofposts) || $link_headline_fullstory )
	{
		$temp_head = replace_masks ($temp_head, array ('linkstart' => '<a href="' . $fn_news_url . $mark . 'fn_mode=fullnews&amp;fn_id=' . $toc['news_id'] . '">'));
	}
	else
	{
		$temp_head = replace_masks ($temp_head, array ('linkstart' => '<a href="' . $fn_news_url . '#fus_' . $toc['news_id'] . '">'));
	}
	
	echo $temp_head;
}

unset ($fn_news_url);

?>