<?php

/*
||==========================================================
||		Fusion News 3.x
||----------------------------------------------------------
|| File Version	: $Id: upgrade_38x_to_39x.php 205 2008-02-15 20:02:29Z xycaleth $
|| Contact	: xycaleth@gmail.com
|| Copyright:	: (c) 2006 - 2008, FusionNews.net
|| License Info	: http://www.gnu.org/copyleft/gpl.html
||==========================================================
*/

error_reporting (E_ALL);

include 'functions.php';
include 'header.php';

$step = ( isset ($_GET['step']) ) ? intval ($_GET['step']) : 1;

switch ( $step )
{
	case 1:
	default:
		echo <<< eof
<p>Before upgrading please backup the following files/directories:</p>
<ul>
	<li>'news' directory (containing toc.php and news.x.php files)</li>
	<li>badwords.txt</li>
	<li>config.php</li>
	<li>smillies.db</li>
</ul>
<p>Once you have done this, <a href="?step=2">proceed to the next step</a>.</p>
eof;
	break;
	
	case 2:
		echo '<h2>Progress</h2>';
		$badwords_file = get_file_lines ('badwords.txt');
		
		$write = DIE_MESSAGE;
		foreach ( $badwords_file as $line )
		{
			list ($find, $replace) = explode ('=', $line);
			$write .= $find . '|<|' . $replace . '|<|0|<|0|<|' . "\n";
		}
		
		if ( write_file ($write, 'badwords.php') === true )
		{
			echo '......Word filter file updated.<br />';
		}
		
		if ( !@unlink ('../badwords.txt') )
		{
			trigger_error ('Unable to delete the old word filter file. Please manually delete this file.', E_USER_NOTICE);
		}
		else
		{
			echo '......Old word filter file deleted.<br />';
		}
		
		$toc_file = get_file_lines ('news/toc.php');
		
		$write = DIE_MESSAGE;
		foreach ( $toc_file as $line )
		{
			list ($news_id) = explode ('|<|', $line);
			
			if ( !file_exists ('../news/news.' . $news_id . '.php') )
			{
				// The news file doesn't exist, so just remove the entry from the TOC.
				continue;
			}
			
			$news_file = get_file_lines ('news/news.' . $news_id . '.php');
			array_shift ($news_file);
			
			$write_2 = DIE_MESSAGE;
			list ($shortnews, $fullnews, $author, $subject, $categories, $timestamp, $commentcount) = explode ('|<|', $news_file[0]);
			$write_2 .= $shortnews . '|<|' . $fullnews . '|<|' . $author . '|<|' . $subject . '|<||<|' . $categories . '|<|' . $timestamp . '|<|' . $commentcount . '|<|' . $news_id . '|<|' . "\n";
			array_shift ($news_file);
			$write_2 .= implode ('', $news_file);
			
			if ( write_file ($write_2, 'news/news.' . $news_id . '.php') === true )
			{
				echo '......News ID ' . $news_id . ' file updated.<br />';
			}
			
			$write .= $news_id . '|<|' . $timestamp . '|<|' . $author . '|<|' . $subject . '|<|' . $categories . '|<|' . "\n";
		}
		
		if ( write_file ($write, 'news/toc.php') === true )
		{
			echo '......News TOC (table of contents) file updated.<br />';
		}
		
		$smileys_file = get_file_lines ('smillies.db');
		
		$write = DIE_MESSAGE;
		foreach ( $smileys_file as $line )
		{
			list ($unique_id, $code, $image) = explode ('|<|', $line);
			$write .= $unique_id . '|<|' . $code . '|<|' . trim ($image) . '|<|' . "\n";
		}
		
		if ( write_file ($write, 'smillies.php') === true )
		{
			echo '......Smileys file updated.<br />';
		}
		
		if ( !@unlink ('../smillies.db') )
		{
			trigger_error ('Unable to delete the old smileys file (smillies.db). Please manually delete this file.', E_USER_NOTICE);
		}
		else
		{
			echo '......Old smileys file deleted.<br />';
		}
		
		update_config();
		echo '......Config file updated.<br />';
		
		echo <<< eof
<p>All files have been updated successfully! You should now add/overwrite the following files with the ones provided in the compressed archive (.zip file, .tar.gz file).</p>
<ul>
	<li>skins/fusion/index.html</li>
	<li>skins/fusion/stylesheet.css</li>
	<li>plugins/check_chmod.php</li>
	<li>archive.php</li>
	<li>comments.php</li>
	<li>common.php</li>
	<li>fullnews.php</li>
	<li>functions.php</li>
	<li>headlines.php</li>
	<li>index.php</li>
	<li>jsfunc.js</li>
	<li>language.db.php</li>
	<li>news.php</li>
	<li>rss.php</li>
	<li>search.php</li>
	<li>send.php</li>
	<li>upload.php</li>
</ul>
<p>Once you have done this, make sure you <strong>delete the /upgrade directory</strong>.</p>
eof;
	break;
}

include 'footer.php';

?>