<?php

/*
||==========================================================
||		Fusion News 3.x
||----------------------------------------------------------
|| File Version	: $Id: upload.php 235 2008-08-05 18:25:14Z xycaleth $
|| Contact	: xycaleth@gmail.com
|| Copyright:	: (c) 2006 - 2007, FusionNews.net
|| License Info	: http://www.gnu.org/copyleft/gpl.html
||==========================================================
*/

include './common.php';

$id = ( !isset ($VARS['id']) ) ? '' : $VARS['id'];
$sid = ( isset ($_COOKIE['fus_sid']) ) ? $_COOKIE['fus_sid'] : '';
$uid = ( isset ($_COOKIE['fus_uid']) ) ? $_COOKIE['fus_uid'] : '';

$userdata = array();
$userdata = login_session_update ($uid, $sid);

if ( !has_access (NEWS_REPORTER) )
{
	echo $ind148;
	exit;
}

if ( !$uploads_active )
{
	echo $upld1;
	exit;
}

if ( strtolower (@ini_get ('file_uploads')) == 'off' || @ini_get ('file_uploads') == 0 || @ini_get ('file_uploads') == '' )
{
	echo
<<< html
<html>
<head>
	<title>$upld3</title>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	<style type="text/css">
	<!--
	body { font-family: "Trebuchet MS", Helvetica, sans-serif; font-size: 10px }
	-->
	</style>
</head>
<body>
$upld2
</body>
</html>
html;
	exit;
}

/**
 * Uploads an image to the 'uploads' directory.
 **/
function upload_file ( $file_number )
{
	global $uploads_ext, $ind252, $ind254, $ind255, $ind255a, $ind256, $ind257;

	$directory = './uploads/';
	//global $upld2, $ind252, $ind253, $ind254, $ind255, $ind255a, $ind256, $ind257;
	
	if ( $_FILES['F']['error'][$file_number] != UPLOAD_ERR_OK )
	{
		// Problem with the upload. Let's take a closer look
		switch ( $_FILES['F']['error'][$file_number] )
		{
			case UPLOAD_ERR_INI_SIZE:
			case UPLOAD_ERR_FORM_SIZE:
				return $ind252;
			break;
			
			case UPLOAD_ERR_PARTIAL:
			break;
			
			case UPLOAD_ERR_NO_FILE:
				return $ind254;
			break;
			
			default:
				return 'Uh-oh, this isn\'t supposed to happen.';
			break;
		}
	}
	
	$filename = ( isset ($_FILES['F']['name'][$file_number]) ) ? $_FILES['F']['name'][$file_number] : '';
	$tmpname = ( isset ($_FILES['F']['tmp_name'][$file_number]) ) ? $_FILES['F']['tmp_name'][$file_number] : '';

	$extensions = explode ('&#124;', $uploads_ext);
	$num_exts = sizeof ($extensions);
	$valid_ext = false;

	foreach ( $extensions as $ext )
	{
		if ( strtolower (substr ($filename, strrpos ($filename, '.') + 1)) == strtolower ($ext) )
		{
			$valid_ext = true;
			break;
		}
	}

	if ( !$valid_ext )
	{
		return $ind255 . $uploads_ext . $ind255a;
	}

	$uploaded = false;

	$origname = $filename;
	$i = 1;

	while ( file_exists ($directory . $filename) )
	{
		$filename = substr ($origname, 0, strrpos ($origname, '.')) . '_' . $i . strrchr ($origname, '.');
		$i++;
	}

	if ( @move_uploaded_file ($tmpname, $directory . $filename) )
	{
		$uploaded = true;
	}
	else if ( @copy ($tmpname, $directory . $filename) )
	{
		$uploaded = true;
	}

	if ( !$uploaded )
	{
		return $ind256;
	}

	@chmod ($upload_path . $filename, 0644);
	@unlink ($tmpname);

	return $_FILES['F']['name'][$file_number] . ' ' . $ind257;
}

$title = '';
$content = '';

if ( !$id || $id == '' )
{
	$title = $upld3;
	$maximum_filesize = calc_size ($uploads_size);

	$content =
<<< html
<ul>
	<li>$upld11 <b>{$furl}/uploads</b>.</li>
	<li>$upld12 {$uploads_ext}.</li>
	<li>$upld13 {$maximum_filesize}.</li>
</ul>
<form method="post" enctype="multipart/form-data" action="?id=upload">
<input type="hidden" name="MAX_FILE_SIZE" value="$uploads_size" />
<fieldset>
	<legend>$upld3</legend>
	<div>
		<label for="F0">$upld14 1</label><br /><input type="file" name="F[]" id="F0" size="50" /><br />
		<label for="F1">$upld14 2</label><br /><input type="file" name="F[]" id="F1" size="50" /><br />
		<label for="F2">$upld14 3</label><br /><input type="file" name="F[]" id="F2" size="50" /><br />
		<label for="F3">$upld14 4</label><br /><input type="file" name="F[]" id="F3" size="50" /><br />
		<label for="F4">$upld14 5</label><br /><input type="file" name="F[]" id="F4" size="50" /><br /><br />
		
		<input type="submit" class="mainoption" value="$ind270">
	</div>
</fieldset>
</form>
html;
}
else if ( $id == 'upload' )
{
	$title = $upld3;
	
	$files_uploaded_list = '';
	$freq_count = array_count_values ($_FILES['F']['error']);
	
	if ( isset ($freq_count[UPLOAD_ERR_NO_FILE]) &&
		$freq_count[UPLOAD_ERR_NO_FILE] >= sizeof ($_FILES['F']['error']) )
	{
		$content = $upld10;
	}	
	else
	{
		foreach ( $_FILES['F']['name'] as $key => $name )
		{
			if ( $_FILES['F']['error'][$key] == UPLOAD_ERR_NO_FILE )
			{
				continue;
			}
			
			$files_uploaded_list .= '<li>' . upload_file ($key) . '</li>';
		}
		
		$content = <<< html
<p>$ind262</p>
<ol>
	$files_uploaded_list
</ol>
<p><a href="?">$upld4</a></p>
html;
	}
}
else if ( $id == 'imagelist' )
{
	$content = <<< html
<p><a href="?id=imagelist">$upld5</a></p>
<table class="data">
	<tr>
		<th style="width:35%">$upld6</th>
		<th style="width:65%">$ind226</th>
	</tr>
html;

	$dir = @opendir ('./uploads');
	if ( $dir !== false )
	{
		$valid_extensions = str_replace ('&#124;', '|', $uploads_ext);
		$has_images = false;
		while ( ($file = readdir ($dir)) !== false )
		{
			if ( $file == '.' || $file == '..' )
			{
				continue;
			}
			
			if ( !preg_match ('#^.+\.' . $valid_extensions . '$#i', strtolower ($file)) )
			{
				continue;
			}
			
			$has_images = true;
			
			$image_info = getimagesize ('./uploads/' . $file);
			$image_width = 400;
			$image_height = 400;
			
			if ( $image_info !== false )
			{
				$image_width = $image_info[0] + 50;
				$image_height = $image_info[1] + 50;
			}
			
			if ( $image_width > 800 )
			{
				$image_width = 800;
			}
			
			if ( $image_height > 800 )
			{
				$image_height = 800;
			}
			
			$content .= <<< html
	<tr>
		<td>[<a href="#" onclick="window.opener.document.getElementById('newsposting').news.value += ' [img]{$furl}/uploads/{$file}[/img] ';">$upld7</a>]&nbsp;[<a href="#" onClick="javascript:opener.document.forms['newsposting'].fullnews.value  += ' [img]{$furl}/uploads/{$file}[/img] ';">$upld8</a>]
		<td><a href="#" onclick="javascript:window_pop ('{$furl}/uploads/{$file}', 'image_preview_{$file}', $image_width, $image_height)">$file</a></td>
	</tr>
	
html;
		}
		
		closedir ($dir);
		
		if ( !$has_images )
		{
			$content .= <<< html
	<tr>
		<td colspan="2" style="text-align:center">$ind300</td>
	</tr>
html;
		}
	}
	else
	{
		$content .= <<< html
	<tr>
		<td colspan="2" style="text-align:center">$upld9</td>
	</tr>
html;
	}

	$content .= <<< html
</table>
html;
}

echo
<<< html
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
	<title>$upld3</title>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	<style type="text/css">
	<!--
	body { margin: 5px; font-size: 100% }
	body, td, input { color: #2D617D; font-family: "Trebuchet MS", Helvetica, sans-serif }
	input { background-color: #DEF1FC; border: 1px solid #A5B8C0 }
	label { cursor:hand }
	fieldset div { margin: 0 auto; width: 75% }
	
	h1 { font-size: 1.5em }
	
	a { color: #2D617D }
	a:hover { color: #22495E; text-decoration: none }
	
	#wrapper { margin: 0 auto; text-align: left; width: 95% }
	#copyright { margin-top: 10px; font-size: 80%; text-align: center; width: 100% }
	
	table.data { border-collapse:collapse; width:100% }
	table.data td, table.data th { border-bottom: 1px solid #999999; padding:2px }
	-->
	</style>
	
	<script type="text/javascript" src="./jsfunc.js"></script>
</head>

<body>
<div id="wrapper">
<h1>$title</h1>
$content
<div id="copyright">Powered by <a href="http://www.fusionnews.net" onclick="window.open (this.href); return false;">Fusion News</a> v{$curve} &copy; 2002 - 2008, FusionNews.net</span>
</div>
</body>

</html>
html;

?>
